config/routes.rb
# set helper method for drawing routes
class ActionDispatch::Routing::Mapper
  def draw(routes_name)
    instance_eval(File.read(Rails.root.join("config/routes/#{routes_name}.rb")))
  end
end

Rails.application.routes.draw do
  root 'dashboard#show'

  get 'dashboard', to: 'dashboard#show', as: 'show_dashboard'

  devise_for :users

  devise_for :admin_users, ActiveAdmin::Devise.config
  ActiveAdmin.routes(self)

  draw :web
end

app/models/company.rb
class Company < ApplicationRecord
  include Notification::NotifiableBase

  attr_accessor :admin_action

  validates :title,
            presence: true
  validates :color,
            :certificate_exp_date,
            :functioning_exp_date,
            :access_key_exp_date,
            :address_city,
            :address_street,
            :address_number,
            presence: true,
            unless: :admin_action?

  has_many :vehicles,
           dependent: :destroy
  has_many :users,
           dependent: :destroy
  has_many :extra_services,
           dependent: :destroy
  has_many :driving_categories,
           dependent: :destroy

  before_validation :set_uniq_title
  # todo: if: -> { title.present? }
  after_update :update_users_usernames

  def full_address
    return @full_address if @full_address.present?

    @full_address = [
      address_city,
      address_street,
      address_number,
      address_building_number,
      address_entrance_number,
      address_floor,
      address_apartment
    ].reject { |c| c.empty? }.join(', ')
  end

  def username_second_part
    "@#{uniq_title}"
  end

  private

  def set_uniq_title
    return false if title.blank?
    return true unless title_changed?

    new_uniq_title = title.gsub(/[^0-9A-Za-z]/, '-').downcase
    i = 1
    while Company.find_by(uniq_title: new_uniq_title)
      new_uniq_title = title.gsub(/[^0-9A-Za-z]/, '-').downcase + "-#{i}"
      i += 1
    end
    self.uniq_title = new_uniq_title
  end

  def update_users_usernames
    return true unless saved_changes["title"].present?

    users.find_each do |user|
      user.update(username: user.username_first_part + username_second_part)
    end
  end

  def admin_action?
    @admin_action
  end
end

app/models/notification/user.rb
class Notification::User < Notification
  default_scope { where(notifiable_type: 'User') }
end

app/models/user.rb
class User < ApplicationRecord
  include Notification::NotifiableBase
  include Detailable::User

  devise :database_authenticatable, :rememberable, :validatable,
         authentication_keys: [:username]

  enum role: { administrator: 0, secretary: 1, instructor: 2, student: 3 }

  validates :username,
            :first_name,
            :last_name,
            :role,
            :company,
            presence: true
  validates :username,
            uniqueness: true
  validates :instructor_detail,
            presence: true, if: :instructor?
  validates :student_detail,
            presence: true, if: :student?
  validates_associated :instructor_detail,
                       :student_detail

  belongs_to :company
  has_one :instructor_detail, # is used for instructor users
          dependent: :destroy
  has_one :student_detail, # is used for student users
          dependent: :destroy
  has_many :vehicles,
           through: :instructor_detail
  has_many :installments,
           through: :student_detail

  accepts_nested_attributes_for :instructor_detail,
                                :student_detail

  before_validation :build_company_username
  before_validation :set_instructor_detail_existence,
                    :set_student_detail_existence

  def full_name
    "#{first_name} #{last_name}"
  end

  def to_dos
    # todos pertaining a user or user's company and are from user's department OR no department
    ToDo.where(company_id: nil, user_id: id)
        .or(ToDo.where(user_id: nil, company_id: company_id))
        .or(ToDo.where(department: [nil, User.roles[role]], company_id: company_id))
  end

  def username_first_part
    username.split('@')[0]
  end
  delegate :username_second_part, to: :company

  private

  def set_instructor_detail_existence
    self.instructor_detail = nil unless instructor?
  end

  def set_student_detail_existence
    self.student_detail = nil unless student?
  end

  def build_company_username
    return false if username.blank?

    self.username = username_first_part + username_second_part
  end

  # devise bypass email validations, we are using username for authenticating
  def email_required?
    false
  end
  def will_save_change_to_email?
    false
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  include AuthorizableResource
  include Autocompletable
  before_action :authorize_resources, only: %i[
    index autocomplete
  ]
  before_action :authorize_resource, only: %i[
    show edit update destroy gdpr disclaimer
  ]

  def index; end

  def new
    @user = current_company.users.new
    authorize(@user)
  end

  def create
    @user = current_company.users.new(user_params)
    authorize(@user)
    if @user.save
      flash[:success] = 'Utilizator adaugat cu success'
      redirect_to user_path(@user)
    else
      render :new
    end
  end

  def show
    @instructor_detail = @user.instructor_detail
    @student_detail = @user.student_detail
  end

  def edit; end

  def update
    update_success = if user_params[:password].present?
                       @user.update(user_params)
                     else
                       @user.update_without_password(user_params)
                     end
    if update_success
      flash[:success] = 'Utilizator schimbat cu success'
      redirect_to user_path(@user)
    else
      render :edit
    end
  end

  def destroy
    @user.destroy
    flash[:success] = 'Utilizator sters cu success'
    redirect_to users_path
  end

  def autocomplete
    resources, attribute = case params[:for].split('.')[0]
                when 'student_details'
                  [StudentDetail.all, params[:for].split('.')[1]]
                when 'instructor_details'
                  [InstructorDetail.all, params[:for].split('.')[1]]
                else
                  [@users, params[:for]]
                end

    render json: autocomplete_response_for(resources, attribute, params[:q])
  end

  def gdpr
    @student_detail = @user.student_detail
    render pdf: 'gdpr', formats: :pdf
  end

  def disclaimer
    render pdf: 'disclaimer', formats: :pdf
  end

  private

  def authorize_resources
    @users = policy_scope(User)
  end

  def authorize_resource
    @user = User.find(params[:id])
    authorize @user
  end

  def user_params
    @user_params = params.require(:user)
                         .permit(policy(:user).permitted_attributes)

    if @user_params[:role] == "student"
      @user_params.except(:instructor_detail_attributes)
    elsif @user_params[:role] == "instructor"
      @user_params.except(:student_detail_attributes)
    end

    @user_params
  end
end

app/helpers/users_helper.rb
module UsersHelper
  def form_employee_detail_for_user(user)
    user.instructor_detail || user.build_instructor_detail
  end

  def hide_instructor_detail_form(user, html_class = '')
    html_class += ' d-none' unless policy(user).can_have_instructor_detail?
    html_class
  end

  def form_student_detail_for_user(user)
    user.student_detail || user.build_student_detail
  end

  def hide_student_detail_form(user, html_class = '')
    html_class += ' d-none' unless policy(user).can_have_student_detail?
    html_class
  end
end

app/views/users/_student_details_form.html.haml
.student_detail_attributes{ class: hide_student_detail_form(@user) }
  .row
    .col
      = render partial: 'form_errors', locals: { object: @user.student_detail } if @user.student_detail&.errors&.any?
  %h3
    = StudentDetail.model_name.human
  = f.fields_for :student_detail, form_student_detail_for_user(@user) do |sd_f|
    .form-group.row
      = sd_f.label :old_name
      = sd_f.text_field :old_name, class: 'form-control'
    .form-group.row
      = sd_f.label :father_first_name
      = sd_f.text_field :father_first_name, class: 'form-control'
    .form-group.row
      = sd_f.label :mother_first_name
      = sd_f.text_field :mother_first_name, class: 'form-control'
    .form-group.row
      = sd_f.label :birthdate
      = sd_f.date_field :birthdate, class: 'form-control'
    .form-group.row
      = sd_f.label :id_doc_type
      = sd_f.select :id_doc_type, options_for_select(StudentDetail.id_doc_types.keys.map { |k| [t("activerecord.attributes.student_detail.id_doc_types.#{k}"), k] }, @user&.student_detail&.id_doc_type), {}, class: 'form-control'
    .form-group.row
      = sd_f.label :id_doc_series
      = sd_f.text_field :id_doc_series, class: 'form-control'
    .form-group.row
      = sd_f.label :id_doc_number
      = sd_f.text_field :id_doc_number, class: 'form-control'
    .form-group.row
      = sd_f.label :id_doc_cnp
      = sd_f.text_field :id_doc_cnp, class: 'form-control'
    .form-group.row
      = sd_f.label :id_doc_exp_date
      = sd_f.date_field :id_doc_exp_date, class: 'form-control'
    .form-group.row
      = sd_f.label :sex
      = sd_f.select :sex, options_for_select(StudentDetail.sexes.keys.map { |k| [t("activerecord.attributes.student_detail.sexes.#{k}"), k] }, @user&.student_detail&.sex), {}, class: 'form-control'
    .form-group.row
      = sd_f.label :phone_number
      = sd_f.text_field :phone_number, class: 'form-control'
    .form-group.row
      = sd_f.label :email
      = sd_f.text_field :contact_email, class: 'form-control'
    .form-group.row
      = sd_f.label :citizenship
      = sd_f.text_field :citizenship, class: 'form-control autocomplete', autocomplete: :none, data: { autocomplete_type: :users, autocomplete_for: :'student_details.citizenship' }
    .form-group.row
      = sd_f.label :address_country
      = sd_f.text_field :address_country, class: 'form-control autocomplete', autocomplete: :none, data: { autocomplete_type: :users, autocomplete_for: :'student_details.address_country' }
    .form-group.row
      = sd_f.label :address_county
      = sd_f.text_field :address_county, class: 'form-control autocomplete', autocomplete: :none, data: { autocomplete_type: :users, autocomplete_for: :'student_details.address_county' }
    .form-group.row
      = sd_f.label :address_city
      = sd_f.text_field :address_city, class: 'form-control autocomplete', autocomplete: :none, data: { autocomplete_type: :users, autocomplete_for: :'student_details.address_city' }
    .form-group.row
      = sd_f.label :address_street
      = sd_f.text_field :address_street, class: 'form-control autocomplete', autocomplete: :none, data: { autocomplete_type: :users, autocomplete_for: :'student_details.address_street' }
    .form-group.row
      = sd_f.label :address_number
      = sd_f.text_field :address_number, class: 'form-control'
    .form-group.row
      = sd_f.label :address_building_number
      = sd_f.text_field :address_building_number, class: 'form-control'
    .form-group.row
      = sd_f.label :address_entrance_number
      = sd_f.text_field :address_entrance_number, class: 'form-control'
    .form-group.row
      = sd_f.label :address_floor
      = sd_f.text_field :address_floor, class: 'form-control'
    .form-group.row
      = sd_f.label :address_apartment
      = sd_f.text_field :address_apartment, class: 'form-control'
    .form-group.row
      = sd_f.label :country_of_birth
      = sd_f.text_field :country_of_birth, class: 'form-control autocomplete', autocomplete: :none, data: { autocomplete_type: :users, autocomplete_for: :'student_details.country_of_birth' }
    .form-group.row
      = sd_f.label :county_of_birth
      = sd_f.text_field :county_of_birth, class: 'form-control autocomplete', autocomplete: :none, data: { autocomplete_type: :users, autocomplete_for: :'student_details.county_of_birth' }
    .form-group.row
      = sd_f.label :city_of_birth
      = sd_f.text_field :city_of_birth, class: 'form-control autocomplete', autocomplete: :none, data: { autocomplete_type: :users, autocomplete_for: :'student_details.city_of_birth' }
    .form-group.row
      = sd_f.label :contract_number
      = sd_f.text_field :contract_number, class: 'form-control', disabled: true, value: sd_f.object.next_contract_number
    .form-group.row
      = sd_f.label :contract_date
      = sd_f.date_field :contract_date, class: 'form-control'
    .form-group.row
      = sd_f.label :group_date
      = sd_f.date_field :group_date, class: 'form-control'
    .form-group.row
      = sd_f.label :duration_in_weeks
      = sd_f.text_field :duration_in_weeks, class: 'form-control'
    .form-group.row
      = sd_f.label :instructor
      = sd_f.select :instructor_id, options_for_select((current_company.users.instructor.pluck(:id, :first_name, :last_name).map { |i| ["#{i[1]} #{i[2]}", i[0]] }), @user&.student_detail&.instructor_id), {}, class: 'form-control'
    .form-group.row
      = sd_f.label :national_register_number
      = sd_f.text_field :national_register_number, class: 'form-control'
    .form-group.row
      = sd_f.label :contract_series
      = sd_f.text_field :contract_series, class: 'form-control'
    .form-group.row
      = sd_f.label :contract_group
      = sd_f.text_field :contract_group, class: 'form-control'
    .form-group.row
      = sd_f.label :driving_category_ids
      = sd_f.select :driving_category_ids, options_for_select(policy_scope(DrivingCategory).pluck(:name, :id), @user&.student_detail&.driving_category_ids), {}, multiple: true, class: 'form-control'
    .form-group.row
      = sd_f.label :extra_service_ids
      = sd_f.select :extra_service_ids, options_for_select(policy_scope(ExtraService).pluck(:name, :id), @user&.student_detail&.driving_category_ids), {}, multiple: true, class: 'form-control'
    .form-group.row
      = sd_f.label :payment_method
      = sd_f.select :payment_method, options_for_select(StudentDetail.payment_methods.keys.map { |k| [t("activerecord.attributes.student_detail.payment_methods.#{k}"), k] }, @user&.student_detail&.payment_method), {}, class: 'form-control'
    .form-group.row
      = sd_f.label :discount_type
      = sd_f.select :discount_type, options_for_select(StudentDetail.discount_types.keys.map { |k| [t("activerecord.attributes.student_detail.discount_types.#{k}"), k] }, @user&.student_detail&.discount_type), { include_blank: 'No discount' }, class: 'form-control'
    .form-group.row
      = sd_f.label :discount_value
      = sd_f.number_field :discount_value, class: 'form-control'
    .form-group.row
      = sd_f.label :discount_reason
      = sd_f.text_field :discount_reason, class: 'form-control'
    .form-group.row
      = sd_f.label :final_price
      = sd_f.number_field :final_price, class: 'form-control'

:javascript
  const DRIVING_CATEOGRY_PRICES = #{ Hash[DrivingCategoryPolicy::Scope.new(current_user, nil).resolve.pluck(:id, :price)].to_json.html_safe };
  const EXTRA_SERVICE_PRICES = #{ Hash[ExtraServicePolicy::Scope.new(current_user, nil).resolve.pluck(:id, :price)].to_json.html_safe };

app/views/users/edit.html.haml
= render partial: 'form'

app/views/users/index.html.haml
.row.mb-3
  .col
    = link_to new_user_path do
      %button.btn.btn-success.mr-3.float-right
        Adauga
%table.table
  %thead
    %tr
      %th
        Username
      %th
        Companie
      %th
        Rol
      %th
  %tbody
    - @users.each do |user|
      %tr
        %td
          = user.username
        %td
          = user.company.title
        %td
          = user.role
        %td
          - unless user == current_user
            - if policy(user).show?
              = link_to 'Afiseaza', user_path(user)
            - if policy(user).edit?
              = link_to 'Editeaza', edit_user_path(user)
            - if policy(user).destroy?
              = link_to 'Stergeti', user_path(user), method: :delete, data: { confirm: 'Sigur doriti sa stergeti?' }

app/views/users/new.html.haml
= render partial: 'form'

app/views/users/show.html.haml
.row
  .col
    = link_to t("global.edit"), edit_user_path(@user)
    = link_to t('activerecord.models.installment.other'), installments_user_path(@user)
  .col
    = link_to user_path(@user), method: :delete, data: { confirm: t("global.confirm_delete") } do
      %button.btn.btn-danger.mr-3.float-right.mb-1
        = t("global.delete")
.row
  .col
    = "#{t("global.documents")}:"
    - if policy(@user).gdpr?
      = link_to t("global.gdpr"), gdpr_user_path(@user)
      |
    - if policy(@user).disclaimer?
      = link_to t("global.disclaimer"), disclaimer_user_path(@user)
      |
.show_resource
  .row
    .col-md-4.col-sm-12
      = t 'activerecord.attributes.user.username'
    .col-md-8.col-sm-12.text-sm-center
      = @user.username
  .row
    .col-md-4.col-sm-12
      = t 'activerecord.attributes.user.first_name'
    .col-md-8.col-sm-12.text-sm-center
      = @user.first_name
  .row
    .col-md-4.col-sm-12
      = t 'activerecord.attributes.user.last_name'
    .col-md-8.col-sm-12.text-sm-center
      = @user.last_name
  .row
    .col-md-4.col-sm-12
      = t 'activerecord.attributes.user.role'
    .col-md-8.col-sm-12.text-sm-center
      = @user.role
  .row
    .col-md-4.col-sm-12
      = Company.model_name.human
    .col-md-8.col-sm-12.text-sm-center
      = @user.company.title

  - if @instructor_detail.present?
    .row.instructor_detail.border.border-secondary.my-2.py-2
      .col
        %h5
          = InstructorDetail.model_name.human
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.id_doc_series'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.id_doc_series
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.id_doc_number'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.id_doc_number
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.id_doc_cnp'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.id_doc_cnp
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.id_doc_exp_date'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.id_doc_exp_date
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.license_series'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.license_series
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.license_exp_date'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.license_exp_date
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.certificate_series'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.certificate_series
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.certificate_number'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.certificate_number
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.certificate_exp_date'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.certificate_exp_date
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.medical_number'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.medical_number
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.medical_exp_date'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.medical_exp_date
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.record_number'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.record_number
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.instructor_detail.record_exp_date'
          .col-md-8.col-sm-12.text-sm-center
            = @instructor_detail.record_exp_date

  - if @student_detail.present?
    .row.student_detail.border.border-secondary.my-2.py-2
      .col
        %h5
          = StudentDetail.model_name.human
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.old_name'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.old_name
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.father_first_name'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.father_first_name
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.mother_first_name'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.mother_first_name
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.birthdate'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.birthdate
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.id_doc_type'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.id_doc_type
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.id_doc_series'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.id_doc_series
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.id_doc_number'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.id_doc_number
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.id_doc_cnp'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.id_doc_cnp
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.id_doc_exp_date'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.id_doc_exp_date
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.sex'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.sex
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.phone_number'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.phone_number
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.contact_email'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.contact_email
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.citizenship'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.citizenship
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.address_country'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.address_country
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.address_county'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.address_county
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.address_city'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.address_city
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.address_street'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.address_street
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.address_number'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.address_number
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.address_building_numbe'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.address_building_number
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.address_entrance_numbe'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.address_entrance_number
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.address_floor'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.address_floor
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.address_apartment'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.address_apartment
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.country_of_birth'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.country_of_birth
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.county_of_birth'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.county_of_birth
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.city_of_birth'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.city_of_birth
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.contract_number'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.contract_number
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.contract_date'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.contract_date
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.group_date'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.group_date
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.duration_in_weeks'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.duration_in_weeks
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.instructor'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.instructor.first_name
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.national_register_numb'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.national_register_number
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.contract_series'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.contract_series
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.contract_group'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.contract_group
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.discount_type'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.discount_type
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.discount_value'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.discount_value
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.discount_reason'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.discount_reason
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.payment_method'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.payment_method
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.final_price'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.final_price
        .row
          .col-md-4.col-sm-12
            = t 'activerecord.attributes.student_detail.created_at'
          .col-md-8.col-sm-12.text-sm-center
            = @student_detail.created_at